

(function($) {
	$.fn.validationEngineLanguage = function() {};
	$.validationEngineLanguage = {
		newLang: function() {
			$.validationEngineLanguage.allRules = 	{"required":{    			// Add your regex rules here, you can take telephone as an example
						"regex":"none",
						"alertText":"* This field is required",
						"alertTextCheckboxMultiple":"* Please select an option",
						"alertTextCheckboxe":"* This checkbox is required"},
					"length":{
						"regex":"none",
						"alertText":"*Between ",
						"alertText2":" and ",
						"alertText3": " characters allowed"},
					"maxCheckbox":{
						"regex":"none",
						"alertText":"* Checks allowed Exceeded"},	
					"minCheckbox":{
						"regex":"none",
						"alertText":"* Please select ",
						"alertText2":" options"},	
					"confirm":{
						"regex":"none",
						"alertText":"* Your field is not matching"},		
					"telephone":{
						"regex":"/^[0-9\-\(\)\ ]+$/",
						"alertText":"* Invalid phone number"},	
					"email":{
						"regex":"/^[a-zA-Z0-9_\.\-]+\@([a-zA-Z0-9\-]+\.)+[a-zA-Z0-9]{2,4}$/",
						"alertText":"* Invalid email address"},	
					"date":{
                         "regex":"/^[0-9]{4}\-\[0-9]{1,2}\-\[0-9]{1,2}$/",
                         "alertText":"* Invalid date, must be in YYYY-MM-DD format"},
					"onlyNumber":{
						"regex":"/^[0-9.\ ]+$/",
						"alertText":"* Numbers only"},	
					"onlyNumberFormate":{
						"regex":"/^[0-9\ ]+$/",
						"alertText":"* Numbers only"},	
					"onlyIPAddress":{
						"regex":"/^(\d{1,3})\.(\d{1,3})\.(\d{1,3})\.(\d{1,3})$/",
						"alertText":"* Invalid IP Address"},	
					"noSpecialCaracters":{
						"regex":"/^[0-9a-zA-Z_.]+$/",
						"alertText":"* No special caracters allowed"},	
					"onlyCaracters":{
						"regex":"/^[0-9a-zA-Z_. ]+$/",
						"alertText":"* No special caracters allowed"},	
					"onlyIPAddress":{
						"regex":"/^([1-9][0-9]{0,2})+\.([1-9][0-9]{0,2})+\.([1-9][0-9]{0,2})+\.([1-9][0-9]{0,2})+$/",
						"alertText":"* only IP Address allowed"},	

					"ajaxUser":{
						"file":"http://http://203.208.198.8/admin/index.php/reseller/validateUser",
						"extraData":"name=eric",
						"alertTextOk":"* This user is available",	
						"alertTextLoad":"* Loading, please wait",
						"alertText":"* This user is already taken"},	
					"ajaxName":{
						"file":"http://http://203.208.198.8/admin/index.php/client/validateUser",
						"alertText":"* This name is already taken",
						"alertTextOk":"* This user is available",	
						"alertTextLoad":"* Loading, please wait"},		
					"onlyLetter":{
						"regex":"/^[a-zA-Z\ \']+$/",
						"alertText":"* Letters only"},
					"validate2fields":{
    					"nname":"validate2fields",
    					"alertText":"* You must have a firstname and a lastname"},	

					"validateCityfields":{
    					"nname":"validateCityfields",
    					"alertText":"* You must have enter your city"},	

					"validateNickName":{
    					"nname":"validateNickName",
    					"alertText":"* You must have enter your Display Name"}	


					}	
					
		}
	}
})(jQuery);

$(document).ready(function() {	
	$.validationEngineLanguage.newLang()
});